//
// Copyright 1998 Omni Development, Inc.  All rights reserved.
//
// Author: Timothy J. Wood <tjw@omnigroup.com>
// Date:   Apr 19, 1998
//
// You may do what ever you want with this example code.  No warranty expressed or implied.
//

#import <Foundation/Foundation.h>

@interface OFPageMonitor : NSObject
{
    struct _OFPageMonitorThreadState *threadState;
}

- initWithAddress: (void *) address
           length: (unsigned long) length;
// Begins monitoring writes to the specified range of pages.  'address' must
// be on a page boundary.  'length' must be a multiple of NSPageSize().
// The input address range must be writable to begin with.

- (void **) modifiedPages;
// Returns a NULL terminated list of modified pages.  This means that you can never
// monitor rights to the first page, but typically this is OK since the first page
// is totally inaccessible under OpenStep/Mach.  This method returns a block of
// memory that should be freed by the caller with NSZoneFree.


@end
