//
// Copyright 1998 Omni Development, Inc.  All rights reserved.
//
// Author: Timothy J. Wood <tjw@omnigroup.com>
// Date:   Apr 19, 1998
//
// You may do what ever you want with this example code.  No warranty expressed or implied.
//

#import <Foundation/Foundation.h>
#import "OFPageMonitor.h"

void main (int argc, const char *argv[])
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    NSMutableData  *bigData;
    unsigned int   *bigBytes;
    unsigned int    bigLength;
    OFPageMonitor  *pageMonitor;
    void          **modifiedPages;
    
    bigLength = 48 * NSPageSize();
    bigData  = [[NSMutableData alloc] initWithLength: bigLength];
    bigBytes = [bigData mutableBytes];

    pageMonitor = [[OFPageMonitor alloc] initWithAddress: bigBytes
                                                  length: bigLength];

    printf("Base address = 0x%08x\n", (unsigned int)bigBytes);
    
    // Write to some pages.  Test writing to the beginning, end and middle of pages.
    // Also test writing the the first and last pages of the region
    bigBytes[NSPageSize() * 0 +  0] = 1;
    bigBytes[NSPageSize()/sizeof(unsigned int) * 2 + 18] = 1;
    bigBytes[NSPageSize()/sizeof(unsigned int) * 4 + NSPageSize()/sizeof(unsigned int) - 1] = 1;
    bigBytes[bigLength/sizeof(unsigned int) - 1] = 1;

    modifiedPages = [pageMonitor modifiedPages];
    while (*modifiedPages) {
        printf("page at 0x%08x (%d) was modified\n",
               (unsigned int)*modifiedPages,
               (unsigned int)(*modifiedPages - (void *)bigBytes) / NSPageSize());
        modifiedPages++;
    }
    
    [pool release];
    exit(0);       // insure the process exit status is 0
}
